Subject: Re: How to update index stat info without reading file content?

From: Junio C Hamano <[email-masked]>
Date: Thu, 11 Sep 2014 13:51:53 -0700

Steffen Prohaska <[email-masked]> writes:

> Hi,
>
> Is there a way to update the stat information recorded in the index without reading the file content from disk?
>
> Starting from a clean working copy with a committed `file`, I'd like 
>
>     touch file
>     git <magic-command> file
>
> to bring the index into essentially the same state as
>
>     touch file
>     git status
>
> but without reading the content of `file`.  (I'd be willing to wait a bit between touch and the magic command, to avoid any racy-git-related code paths.)
>
> `git-update-index --assume-unchanged` is related.  But it requires completely manual handling of changes, because git will not look at marked files until told otherwise with `--no-assume-unchanged`.  I'd like to tell git only that the current file content is known to be up-to-date.  Any future changes should be handled as usual.

Yes, "assume-unchanged" is related and it is often abused by
clueless.  The only thing it does is by setting the bit, you promise
Git that the one on the filesystem will be kept the same as the
object recorded in the index forever, one of the implications of
which is that Git is free to use either the version on the
filesystem or data read with read_sha1_file() from the object store,
whichever it finds more convenient, when it needs to read the data
for the object recorded in the index for the path.  You are not
promising the "forever" part, so it is not a good match for what you
are trying to do.

> In the documentation, `git add --refresh file` sounds a bit like
> what I'm looking for.  The documentation of `--refresh` states:
> "Don’t add the file(s), but only refresh their stat() information
> in the index."  But it doesn't do what I want.

No.  It is the same as "update-index --refresh".  You tell it "I've
made this file, which may have had contents different from the
object name recorded in the index before, back to match what is
recorded in the index.", it makes sure that you are not lying, and
then updates the cached stat information so that the next time it
does not have to read the contents.